<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Automate cellulaire:  Fichier source de src/fichier_configuration.c</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Automate cellulaire
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">fichier_configuration.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="fichier__configuration_8c.html">Aller à la documentation de ce fichier.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;fichier_configuration.h&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//                           Structure                        //</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="structfichier__configuration.html">   32</a></span>&#160;<span class="comment"></span><span class="keyword">struct </span><a class="code" href="structfichier__configuration.html">fichier_configuration</a> {</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#a441b3f030abb5b30543968f9f1a5be0d">   33</a></span>&#160;  <span class="keywordtype">char</span>* <a class="code" href="structfichier__configuration.html#a441b3f030abb5b30543968f9f1a5be0d">regle</a>;</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#aa14cbe479b974778f69205c5f573f0aa">   34</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structfichier__configuration.html#aa14cbe479b974778f69205c5f573f0aa">nb_etat</a>;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#ac3fc21fbeb899cb37ea7857bd2f5771b">   35</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structfichier__configuration.html#ac3fc21fbeb899cb37ea7857bd2f5771b">hauteur</a>;</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#a57e9bc2e6956d6fbbb7c6045ecbeac32">   36</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structfichier__configuration.html#a57e9bc2e6956d6fbbb7c6045ecbeac32">largeur</a>;</div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#adad9a37061420fd84387f25b6a83b609">   37</a></span>&#160;  <span class="keywordtype">char</span> <a class="code" href="structfichier__configuration.html#adad9a37061420fd84387f25b6a83b609">cellule_symbole</a>;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#a77928a6819cdd77313e2b62249512fbf">   38</a></span>&#160;  <span class="keywordtype">char</span>* <a class="code" href="structfichier__configuration.html#a77928a6819cdd77313e2b62249512fbf">emplacement_initial</a>;</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#ab267b680af93f62025924c996a89fd00">   39</a></span>&#160;  <span class="keywordtype">bool</span> <a class="code" href="structfichier__configuration.html#ab267b680af93f62025924c996a89fd00">enregistrer_image</a>;</div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="structfichier__configuration.html#a9512fa1069b7922c64de2f769d89a81b">   40</a></span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structfichier__configuration.html#a9512fa1069b7922c64de2f769d89a81b">nb_magique</a>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;};</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">//                        Constructeur                        //</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#ad80bfd5b28d3fc81e66d83fa23690e88">   54</a></span>&#160;<span class="comment"></span>ptr_str_fc <a class="code" href="fichier__configuration_8c.html#ad80bfd5b28d3fc81e66d83fa23690e88">creer_fichier_configuration</a>( <span class="keyword">const</span> <span class="keywordtype">char</span>* nom_fichier ){</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;  <span class="comment">// Création d&#39;un fichier</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;  FILE* fichier = fopen( nom_fichier, <span class="stringliteral">&quot;r&quot;</span> );</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;  <span class="keywordflow">if</span>( fichier == NULL ){</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;ouverture du fichier %s\n&quot;</span>, nom_fichier);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    exit(EXIT_FAILURE );</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;  }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  <span class="comment">// Création d&#39;une structure fichier_configuration</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  ptr_str_fc f_config = (ptr_str_fc)malloc( <span class="keyword">sizeof</span>(<span class="keyword">struct</span> <a class="code" href="structfichier__configuration.html">fichier_configuration</a>) );</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="keywordflow">if</span>( f_config == NULL ){</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    fprintf(stderr, <span class="stringliteral">&quot;Erreur de création d&#39;une structure fichier_configuration\n&quot;</span>);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    exit(EXIT_FAILURE );</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  }</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  f_config-&gt;emplacement_initial = NULL;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  f_config-&gt;regle = NULL;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <span class="comment">// Lecture des paramètres du fichier de configuration</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  <a class="code" href="fichier__configuration_8c.html#aaa4841f314f9c7b1eb6130886505c149">lecture_fichier_configuration</a>(fichier, f_config);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;  fclose( fichier );</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  <span class="keywordflow">return</span> f_config;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;}</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160; </div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">//                         Accesseurs                         //</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">   89</a></span>&#160;<span class="comment"></span><span class="keywordtype">char</span>* <a class="code" href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;regle;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;}</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160; </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">  100</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;nb_etat;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;}</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">  111</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;hauteur;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;}</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">  122</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;largeur;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;}</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160; </div>
<div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#a50675bf48ff97d3282760437d7e9c69e">  133</a></span>&#160;<span class="keywordtype">char</span> <a class="code" href="fichier__configuration_8c.html#a50675bf48ff97d3282760437d7e9c69e">get_cellule_symbole</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;cellule_symbole;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;}</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160; </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#a21bb44a3b30408468720e6eb6eaa60ac">  144</a></span>&#160;<span class="keywordtype">char</span>* <a class="code" href="fichier__configuration_8c.html#a21bb44a3b30408468720e6eb6eaa60ac">get_emplacement_initial</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;emplacement_initial;</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;}</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160; </div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">  156</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">get_enregistrer_image</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;enregistrer_image;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;}</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160; </div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160; </div>
<div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">  167</a></span>&#160;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;  <span class="keywordflow">return</span> f_config-&gt;nb_magique;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;}</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160; </div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160; </div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment">//                       Autres Fonctions                     //</span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00181"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#aaa4841f314f9c7b1eb6130886505c149">  181</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="fichier__configuration_8c.html#aaa4841f314f9c7b1eb6130886505c149">lecture_fichier_configuration</a>(FILE* fichier, ptr_str_fc f_config){</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160; </div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;  <span class="keyword">enum</span> etats { ENREGISTRER_IMAGE, NOMBRE_ETAT, REGLE, HAUTEUR, LARGEUR, CELLULE_SYMBOLE, EMPLACEMENT_INITIAL, NOMBRE_MAGIQUE };</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;  <span class="keyword">enum</span> etats etat = ENREGISTRER_IMAGE;</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;  <span class="keyword">const</span> <span class="keywordtype">int</span> MAX_LENGTH = 2000;</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;  <span class="keywordtype">char</span>* buf = (<span class="keywordtype">char</span>*)malloc( <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) * MAX_LENGTH );</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;  <span class="keywordflow">if</span>(buf == NULL) {</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;     fprintf(stderr, <span class="stringliteral">&quot;L&#39;allocation memoire a echoue.&quot;</span>);</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;     exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;  }</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;  <span class="keywordtype">bool</span> lire_fichier = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;  <span class="keywordtype">char</span>* enregistrer_str;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;  <span class="keywordtype">char</span>* emp_initial;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;  <span class="keywordtype">char</span>* regle_tmp;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;  <span class="keywordtype">int</span> nombre_etat_tmp;</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;  <span class="keywordtype">int</span> hauteur_tmp;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;  <span class="keywordtype">int</span> largeur_tmp;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160; </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;  <span class="keywordflow">while</span>( lire_fichier ){</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    <span class="keywordflow">if</span>( fgets(buf, MAX_LENGTH, fichier) == NULL ){</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;      lire_fichier = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    }</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    <span class="keywordflow">while</span>( strncmp(buf, <span class="stringliteral">&quot;#&quot;</span>, 1) == 0 || strncmp(buf, <span class="stringliteral">&quot;\n&quot;</span>, 1) == 0 ){</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;      fgets(buf, MAX_LENGTH, fichier);</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    }</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordflow">switch</span>( etat ){</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160; </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;      <span class="comment">// Récupération de la valeur &quot;YES&quot; ou &quot;NO&quot; pour savoir si </span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;      <span class="comment">// l&#39;utilisateur souhaite enregistrer son automate en image ou non.</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;      <span class="keywordflow">case</span> ENREGISTRER_IMAGE:</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;      enregistrer_str = (<span class="keywordtype">char</span>*)malloc( <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) * 3 + 1);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;      <span class="keywordflow">if</span>( enregistrer_str == NULL ){</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation du tableau pour l&#39;enregistrement de l&#39;image \n&quot;</span>);</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;      }</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;      <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;ENREGISTREMENT = %s&quot;</span>, enregistrer_str) == 1){</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keywordflow">if</span>( strcmp(enregistrer_str, <span class="stringliteral">&quot;YES&quot;</span>) == 0 ) f_config-&gt;enregistrer_image = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span>( strcmp(enregistrer_str, <span class="stringliteral">&quot;NO&quot;</span>) == 0 ) f_config-&gt;enregistrer_image = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;ENREGISTREMENT&#39; n&#39;est pas valide.\n&quot;</span>);</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        }</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        etat = NOMBRE_ETAT;</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;      }</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;ENREGISTREMENT&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;      }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;      free( enregistrer_str );</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;      enregistrer_str = NULL;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160; </div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;      <span class="comment">// On récupère le nombre d&#39;état possible</span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;      <span class="keywordflow">case</span> NOMBRE_ETAT:</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;      <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;NOMBRE_ETATS = %d&quot;</span>, &amp;nombre_etat_tmp) == 1){</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        <span class="keywordflow">if</span> (nombre_etat_tmp &gt;= 2){</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;          f_config-&gt;nb_etat = nombre_etat_tmp;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;          etat = REGLE;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        }</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;NOMBRE_ETATS&#39; n&#39;est pas valide.\nIl faut minimum deux etats.\n&quot;</span>);</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        }</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;      }</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;NOMBRE_ETATS&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;      }</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160; </div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;      <span class="comment">// Récupération de la règle en chaine de caractère</span></div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;      <span class="keywordflow">case</span> REGLE:</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;      <span class="keywordflow">if</span> (f_config-&gt;nb_etat == 2){</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        regle_tmp = (<span class="keywordtype">char</span>*)malloc(<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) * 8 + 1);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;      }</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;      <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        regle_tmp = (<span class="keywordtype">char</span>*)malloc(<span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) * ((f_config-&gt;nb_etat - 1) * 3 + 1) + 1);</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;      }</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;      <span class="keywordflow">if</span>( regle_tmp == NULL ){</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation du tableau pour la regle\n&quot;</span>);</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;      }</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;      <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;REGLE = %s&quot;</span>, regle_tmp) == 1){</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        <span class="comment">// tester s&#39;il y a bien le bon nombre de chiffres</span></div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordflow">if</span>(f_config-&gt;nb_etat == 2 &amp;&amp; strlen(regle_tmp) != 8){</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation de la regle\nPour deux etats, la regle doit etre ecrit en binaire sous forme d&#39;un octet.\n&quot;</span>);</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        }</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span>(f_config-&gt;nb_etat &gt; 2 &amp;&amp; strlen(regle_tmp) != (f_config-&gt;nb_etat - 1) * 3 + 1){</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation de la regle\nPour %d etats, la regle doit avoir %d chiffres.\n&quot;</span>, f_config-&gt;nb_etat , (f_config-&gt;nb_etat - 1) * 3 + 1);</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        }</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="comment">// tester si les chiffres entres sont correctes</span></div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; strlen(regle_tmp); i++) {</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;          <span class="keywordflow">if</span> ((<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)(regle_tmp[i] - <span class="charliteral">&#39;0&#39;</span>) &gt;= f_config-&gt;nb_etat){</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;              fprintf(stderr, <span class="stringliteral">&quot;Erreur de saisie de la regle\nPour %d etats, les chiffres doivent etre compris entre 0 et %d.\n&quot;</span>, f_config-&gt;nb_etat , f_config-&gt;nb_etat - 1);</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;              exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;          }</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        }</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        f_config-&gt;regle = regle_tmp;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        regle_tmp = NULL;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        etat = HAUTEUR;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;      }</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;REGLE&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;      }</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160; </div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;      <span class="comment">// Lecture ded la hauteur de l&#39;automate</span></div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;      <span class="keywordflow">case</span> HAUTEUR:</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;      <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;HAUTEUR = %d&quot;</span>, &amp;hauteur_tmp) == 1){</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        <span class="keywordflow">if</span> ( hauteur_tmp &gt; 1){</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;          f_config-&gt;hauteur = hauteur_tmp;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;          etat = LARGEUR;</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        }</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation de l&#39;hauteur\nVeuillez indiquer un entier positif.\n&quot;</span>);</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        }</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;      }</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;HAUTEUR&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;      }</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160; </div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;      <span class="comment">// Récupération de la largeur</span></div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;      <span class="keywordflow">case</span> LARGEUR:</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;      <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;LARGEUR = %d&quot;</span>, &amp;largeur_tmp) == 1){</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        <span class="keywordflow">if</span> ( largeur_tmp &gt; 1){</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;          f_config-&gt;largeur = largeur_tmp;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;          etat = LARGEUR;</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        }</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation de la largeur\nVeuillez indiquer un entier positif.\n&quot;</span>);</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        }</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        etat = CELLULE_SYMBOLE;</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;      }</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;LARGEUR&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;      }</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160; </div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;      <span class="comment">// Lecture du caractère utilisé pour représenter une cellule dite &quot;vivante&quot;</span></div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;      <span class="keywordflow">case</span> CELLULE_SYMBOLE:</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;CELLULE_SYMBOLE = %c&quot;</span>, &amp;f_config-&gt;cellule_symbole) == 1) etat = EMPLACEMENT_INITIAL;</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span>( !f_config-&gt;enregistrer_image ){</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;CELLULE_SYMBOLE&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        }</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160; </div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;      <span class="comment">// Lecture de la ligne d&#39;initialiation</span></div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;      <span class="keywordflow">case</span> EMPLACEMENT_INITIAL:</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;      emp_initial = (<span class="keywordtype">char</span>*)malloc(f_config-&gt;largeur * <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>) + 1);</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;      <span class="keywordflow">if</span>( emp_initial == NULL ){</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;Erreur d&#39;initialisation du tableau pour les emplacements initials\n&quot;</span>);</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;      }</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;      <span class="keywordflow">if</span>(sscanf(buf, <span class="stringliteral">&quot;EMPLACEMENT_INITIAL = %s&quot;</span>, emp_initial) == 1){</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;        <span class="comment">// Initialiser aleatoirement les cellules de l&#39;automate</span></div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        <span class="keywordflow">if</span> (strcmp(emp_initial,  <span class="stringliteral">&quot;ALEATOIRE&quot;</span>) == 0) {</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;          <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; f_config-&gt;largeur; i++) {</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;            emp_initial[i] = (char)(rand() % f_config-&gt;nb_etat) + <span class="charliteral">&#39;0&#39;</span>;</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;          }</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        }</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span>( strlen( emp_initial ) != f_config-&gt;largeur ){</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;          fprintf(stderr, <span class="stringliteral">&quot;La chaîne %s doit contenir %d chiffres.\n&quot;</span>, emp_initial, f_config-&gt;largeur);</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;          exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        }</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;        <span class="keywordflow">else</span>{</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;          <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; f_config-&gt;largeur; i++) {</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;            <span class="keywordflow">if</span> (emp_initial[i] - <span class="charliteral">&#39;0&#39;</span> &gt; (<span class="keywordtype">int</span>)f_config-&gt;nb_etat){</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;              fprintf(stderr, <span class="stringliteral">&quot;La chaîne %s doit contenir des chiffres entre 0 et %u.\n&quot;</span>, emp_initial, f_config-&gt;nb_etat);</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;              exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;            }</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;          }</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        }</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160; </div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        f_config-&gt;emplacement_initial = emp_initial;</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        emp_initial = NULL;</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        etat = NOMBRE_MAGIQUE;</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;      }</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;      <span class="keywordflow">else</span> {</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;EMPLACEMENT_INITIAL&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;      }</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160; </div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;      <span class="comment">// Lecture du nombre magique qui détermine le format d&#39;enregistrement</span></div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;      <span class="comment">// de l&#39;image (ASCII ou Binaire)</span></div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;      <span class="keywordflow">case</span> NOMBRE_MAGIQUE:</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;      <span class="keywordflow">if</span>( sscanf(buf, <span class="stringliteral">&quot;NOMBRE_MAGIQUE = P%ud&quot;</span>, &amp;f_config-&gt;nb_magique) == 0 &amp;&amp; !f_config-&gt;enregistrer_image ){</div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;        fprintf(stderr, <span class="stringliteral">&quot;FICHIER CONFIG: le paramètre &#39;NOMBRE_MAGIQUE&#39; n&#39;est pas renseigné\n&quot;</span>);</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;        exit(EXIT_FAILURE);</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;      }</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;      lire_fichier = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;      <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    }</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;  }</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;  free( buf );</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;  buf = NULL;</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;}</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160; </div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160; </div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;<span class="comment">//                         Suppression                        //</span></div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00399"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#a8e23c05945f10746ec4182b61123af00">  399</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="fichier__configuration_8c.html#a8e23c05945f10746ec4182b61123af00">delete_fichier_configuration</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;  free( f_config-&gt;emplacement_initial );</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;  <span class="keywordflow">if</span> (f_config-&gt;nb_etat &gt; 2)</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;    free( f_config-&gt;regle );</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;  free( f_config );</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;  f_config = NULL;</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;}</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160; </div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160; </div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;<span class="comment">//                          Affichage                         //</span></div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;<span class="comment">//------------------------------------------------------------//</span></div>
<div class="line"><a name="l00416"></a><span class="lineno"><a class="line" href="fichier__configuration_8c.html#a47a2d2c118d7e2b8ae5e68f3344808e6">  416</a></span>&#160;<span class="comment"></span><span class="keywordtype">void</span> <a class="code" href="fichier__configuration_8c.html#a47a2d2c118d7e2b8ae5e68f3344808e6">afficher_fichier_configuration</a>( ptr_str_fc f_config ){</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;  printf(<span class="stringliteral">&quot;enregistrer image : %d\n&quot;</span>, f_config-&gt;enregistrer_image);</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;  printf(<span class="stringliteral">&quot;regle : %s\n&quot;</span>, f_config-&gt;regle);</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;  printf(<span class="stringliteral">&quot;nombre etats : %u\n&quot;</span>, f_config-&gt;nb_etat);</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;  printf(<span class="stringliteral">&quot;hauteur : %u\n&quot;</span>, f_config-&gt;hauteur);</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;  printf(<span class="stringliteral">&quot;largeur : %u\n&quot;</span>, f_config-&gt;largeur);</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;  printf(<span class="stringliteral">&quot;cellule symbole : %c\n&quot;</span>, f_config-&gt;cellule_symbole);</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;  printf(<span class="stringliteral">&quot;emplacement initial : %s\n&quot;</span>, f_config-&gt;emplacement_initial);</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;  printf(<span class="stringliteral">&quot;nombre magique : %u\n&quot;</span>, f_config-&gt;nb_magique);</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructfichier__configuration_html_ac3fc21fbeb899cb37ea7857bd2f5771b"><div class="ttname"><a href="structfichier__configuration.html#ac3fc21fbeb899cb37ea7857bd2f5771b">fichier_configuration::hauteur</a></div><div class="ttdeci">unsigned int hauteur</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00035">fichier_configuration.c:35</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a47a2d2c118d7e2b8ae5e68f3344808e6"><div class="ttname"><a href="fichier__configuration_8c.html#a47a2d2c118d7e2b8ae5e68f3344808e6">afficher_fichier_configuration</a></div><div class="ttdeci">void afficher_fichier_configuration(ptr_str_fc f_config)</div><div class="ttdoc">Affiche les attributs de la structure fichier_configuration.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00416">fichier_configuration.c:416</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a0747aaffe60671eda2ba956722a8c191"><div class="ttname"><a href="fichier__configuration_8c.html#a0747aaffe60671eda2ba956722a8c191">get_enregistrer_image</a></div><div class="ttdeci">bool get_enregistrer_image(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;enregistrer_image&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00156">fichier_configuration.c:156</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_a441b3f030abb5b30543968f9f1a5be0d"><div class="ttname"><a href="structfichier__configuration.html#a441b3f030abb5b30543968f9f1a5be0d">fichier_configuration::regle</a></div><div class="ttdeci">char * regle</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00033">fichier_configuration.c:33</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_a77928a6819cdd77313e2b62249512fbf"><div class="ttname"><a href="structfichier__configuration.html#a77928a6819cdd77313e2b62249512fbf">fichier_configuration::emplacement_initial</a></div><div class="ttdeci">char * emplacement_initial</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00038">fichier_configuration.c:38</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afc113bc5216673e023757de45be2e009"><div class="ttname"><a href="fichier__configuration_8c.html#afc113bc5216673e023757de45be2e009">get_hauteur</a></div><div class="ttdeci">unsigned int get_hauteur(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;hauteur&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00111">fichier_configuration.c:111</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a1b660f6a0cca911778798dfe26976cdd"><div class="ttname"><a href="fichier__configuration_8c.html#a1b660f6a0cca911778798dfe26976cdd">get_largeur</a></div><div class="ttdeci">unsigned int get_largeur(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;largeur&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00122">fichier_configuration.c:122</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_afef69ee54144409041ea66d6e1185312"><div class="ttname"><a href="fichier__configuration_8c.html#afef69ee54144409041ea66d6e1185312">get_nb_etat</a></div><div class="ttdeci">unsigned int get_nb_etat(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_etat&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00100">fichier_configuration.c:100</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_adad9a37061420fd84387f25b6a83b609"><div class="ttname"><a href="structfichier__configuration.html#adad9a37061420fd84387f25b6a83b609">fichier_configuration::cellule_symbole</a></div><div class="ttdeci">char cellule_symbole</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00037">fichier_configuration.c:37</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a50675bf48ff97d3282760437d7e9c69e"><div class="ttname"><a href="fichier__configuration_8c.html#a50675bf48ff97d3282760437d7e9c69e">get_cellule_symbole</a></div><div class="ttdeci">char get_cellule_symbole(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;cellule_symbole&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00133">fichier_configuration.c:133</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_ab267b680af93f62025924c996a89fd00"><div class="ttname"><a href="structfichier__configuration.html#ab267b680af93f62025924c996a89fd00">fichier_configuration::enregistrer_image</a></div><div class="ttdeci">bool enregistrer_image</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00039">fichier_configuration.c:39</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_a57e9bc2e6956d6fbbb7c6045ecbeac32"><div class="ttname"><a href="structfichier__configuration.html#a57e9bc2e6956d6fbbb7c6045ecbeac32">fichier_configuration::largeur</a></div><div class="ttdeci">unsigned int largeur</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00036">fichier_configuration.c:36</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_aa14cbe479b974778f69205c5f573f0aa"><div class="ttname"><a href="structfichier__configuration.html#aa14cbe479b974778f69205c5f573f0aa">fichier_configuration::nb_etat</a></div><div class="ttdeci">unsigned int nb_etat</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00034">fichier_configuration.c:34</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_aaa4841f314f9c7b1eb6130886505c149"><div class="ttname"><a href="fichier__configuration_8c.html#aaa4841f314f9c7b1eb6130886505c149">lecture_fichier_configuration</a></div><div class="ttdeci">void lecture_fichier_configuration(FILE *fichier, ptr_str_fc f_config)</div><div class="ttdoc">Lire les valeurs des paramètres du fichier de configuration (ASCII) passé en paramètre.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00181">fichier_configuration.c:181</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_ad80bfd5b28d3fc81e66d83fa23690e88"><div class="ttname"><a href="fichier__configuration_8c.html#ad80bfd5b28d3fc81e66d83fa23690e88">creer_fichier_configuration</a></div><div class="ttdeci">ptr_str_fc creer_fichier_configuration(const char *nom_fichier)</div><div class="ttdoc">Créer un pointeur de pointeur de structure fichier_configuration à partir du nom du fichier que l'éxe...</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00054">fichier_configuration.c:54</a></div></div>
<div class="ttc" id="astructfichier__configuration_html_a9512fa1069b7922c64de2f769d89a81b"><div class="ttname"><a href="structfichier__configuration.html#a9512fa1069b7922c64de2f769d89a81b">fichier_configuration::nb_magique</a></div><div class="ttdeci">unsigned int nb_magique</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00040">fichier_configuration.c:40</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a8e23c05945f10746ec4182b61123af00"><div class="ttname"><a href="fichier__configuration_8c.html#a8e23c05945f10746ec4182b61123af00">delete_fichier_configuration</a></div><div class="ttdeci">void delete_fichier_configuration(ptr_str_fc f_config)</div><div class="ttdoc">Déalou la mémoire utilisé par la structure fichier_configuration ainsi que ses attributs.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00399">fichier_configuration.c:399</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_af66f6107d4b7f6e4de23bd6f697ccaf8"><div class="ttname"><a href="fichier__configuration_8c.html#af66f6107d4b7f6e4de23bd6f697ccaf8">get_nb_magique</a></div><div class="ttdeci">unsigned int get_nb_magique(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;nb_magique&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00167">fichier_configuration.c:167</a></div></div>
<div class="ttc" id="astructfichier__configuration_html"><div class="ttname"><a href="structfichier__configuration.html">fichier_configuration</a></div><div class="ttdoc">Une structure pour stocker les paramètres des fichiers de configuration des automates cellulaire.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00032">fichier_configuration.c:32</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_a21bb44a3b30408468720e6eb6eaa60ac"><div class="ttname"><a href="fichier__configuration_8c.html#a21bb44a3b30408468720e6eb6eaa60ac">get_emplacement_initial</a></div><div class="ttdeci">char * get_emplacement_initial(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;emplacement_initial&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00144">fichier_configuration.c:144</a></div></div>
<div class="ttc" id="afichier__configuration_8c_html_ae0ce5e18cc06c038b2ae5ab594e5e9e7"><div class="ttname"><a href="fichier__configuration_8c.html#ae0ce5e18cc06c038b2ae5ab594e5e9e7">get_regle</a></div><div class="ttdeci">char * get_regle(ptr_str_fc f_config)</div><div class="ttdoc">Retourne l'attribut &quot;regle&quot;.</div><div class="ttdef"><b>Definition:</b> <a href="fichier__configuration_8c_source.html#l00089">fichier_configuration.c:89</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Généré par &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
